﻿using System.Web.Mvc;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.MvcEdition;

namespace MvcApplication7.Controllers
{
    public class MapProjectionController : Controller
    {
        //
        // GET: /MapProjection/

        public ActionResult MapProjection()
        {
            Map map = new Map("Map1",
        new System.Web.UI.WebControls.Unit(100, System.Web.UI.WebControls.UnitType.Percentage),
        510);
            map.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
            GoogleOverlay googleOverlay = new GoogleOverlay();
            map.CustomOverlays.Add(googleOverlay);

            map.MapUnit = GeographyUnit.Meter;
            map.MapTools.OverlaySwitcher.Enabled = true;

            Proj4Projection projection = new Proj4Projection();

            projection.MemoryMode = Proj4MemoryMode.Unmanaged;
            projection.ExternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(32723);
            projection.InternalProjectionParametersString = Proj4Projection.GetDecimalDegreesParametersString();
            projection.Open();

            PointShape p = new PointShape(-100, -20);

            InMemoryMarkerOverlay markerOverlay = new InMemoryMarkerOverlay("MarkerOverlay");
            markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage.ImageWidth = 21;
            markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage.ImageHeight = 25;
            markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage.ImageOffsetX = -10.5f;
            markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage.ImageOffsetY = -25f;
            markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            markerOverlay.FeatureSource.Open();
            markerOverlay.FeatureSource.BeginTransaction();
            markerOverlay.FeatureSource.AddFeature(p);
            markerOverlay.FeatureSource.CommitTransaction();
            markerOverlay.FeatureSource.Projection = projection;
            map.CustomOverlays.Add(markerOverlay);
            map.CurrentExtent = projection.ConvertToExternalProjection(new RectangleShape(-125, 72, 50, -46));

            return View(map);
        }

    }
}
